<template>
  <div id="question-box" class="container">
    <div id="info-box">
      <h4 ref="progress" class="info progress"></h4>
      <h4 ref="category" class="info category"></h4>
      <h4 class="info score">Score: {{ score }}</h4>
      <h4 ref="diff" class="info diff"></h4>
    </div>
    <h2 ref="qText"></h2>
    <div ref="answers" v-if="loaded" id="choice-box">
      <button v-for="answer in answers" :key="answer" @click="answerEvent(answer)" v-html="answer"></button>
    </div>
  </div>
</template>

<script>
export default {
    name: 'QuestionScreen',
    data() {
      return {
        answers: [],
        currentQuestion: 0,
        loaded: false
      }
    },
    props: ['questions', 'score'],
    mounted() {
      this.getQuestion(0);
      this.loaded = true;
    },
    methods: {
      getQuestion(id) {
        this.$refs.progress.innerText = `Progress: ${this.currentQuestion + 1}/${this.questions.length}`;
        this.$refs.diff.innerText = `Difficulty: ${this.questions[id].difficulty}`;
        this.$refs.category.innerText = `Category: ${this.questions[id].category}`;
        this.$refs.qText.innerHTML = this.questions[id].question;

        let answers = [];
        this.questions[id].incorrect_answers.forEach(element => {
          answers.push(element);
        });
        answers.push(this.questions[id].correct_answer);
        answers = this.shuffle(answers);
        this.answers = answers;
        this.questions[id].answers = answers;
      },

      // Shuffling algo found on StackOverflow: https://stackoverflow.com/a/2450976
      shuffle(array) {
        var currentIndex = array.length, temporaryValue, randomIndex;

        // While there remain elements to shuffle...
        while (0 !== currentIndex) {

          // Pick a remaining element...
          randomIndex = Math.floor(Math.random() * currentIndex);
          currentIndex -= 1;

          // And swap it with the current element.
          temporaryValue = array[currentIndex];
          array[currentIndex] = array[randomIndex];
          array[randomIndex] = temporaryValue;
        }

        return array;
      },
      answerEvent(answer) {
        this.$emit('answer-event', answer);
        if (this.currentQuestion < this.questions.length - 1) {
          this.getQuestion(++this.currentQuestion);
        }
      }
    }
}
</script>

<style>

</style>